﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Syncfusion.UI.Xaml.Grid;
using System.Windows.Input;
using System.Windows.Controls;
using Syncfusion.UI.Xaml.Grid.Cells;
using System.Windows;
using Syncfusion.UI.Xaml.Utility;

namespace EnterKeyBehavior
{
    public class CustomSfMultiColumnDropDown : SfMultiColumnDropDownControl
    {

        internal TextBox TextEditor
        {
            get { return this.Editor; }
        }
        protected override void ProcessKeyDown(KeyEventArgs args)
        {
            if (args.Key == Key.Enter)
            {
                args.Handled = false;
                return;
            }
            base.ProcessKeyDown(args);
        }
    }

    public class GridCellMultiColumnDropDownRendererExt : GridCellMultiColumnDropDownRenderer
    {
        CustomSfMultiColumnDropDown multiColumnControl;
        protected override SfMultiColumnDropDownControl OnCreateEditUIElement()
        {
            return new CustomSfMultiColumnDropDown();
        }

        public override object GetControlValue()
        {
            if (!HasCurrentCellState) return base.GetControlValue();
            if (IsInEditing)
                return (((CustomSfMultiColumnDropDown)CurrentCellRendererElement).TextEditor as FrameworkElement).GetValue(TextBox.TextProperty);

            return CurrentCellRendererElement.GetValue(TextBlock.TextProperty);
        }
        protected override void OnEditElementLoaded(object sender, RoutedEventArgs e)
        {
            base.OnEditElementLoaded(sender, e);
            multiColumnControl = sender as CustomSfMultiColumnDropDown;
            TextBox textBox = (TextBox)GridUtil.FindDescendantChildByType(multiColumnControl, typeof(TextBox));
            textBox.TextChanged += TextBox_TextChanged;
            textBox.AcceptsReturn = true;
        }

        private void TextBox_TextChanged(object sender, TextChangedEventArgs e)
        {
            base.CurrentRendererValueChanged();
        }
    }
}
