﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EnterKeyBehavior
{
    public class ViewModel : INotifyPropertyChanged
    {
        private string text = "Syncfusion";

        public string Txt
        {
            get { return text; }
            set
            {
                text = value;
                OnPropertyChanged("Txt");
            }
        }

        private ObservableCollection<Product> product;

        public ObservableCollection<Product> Products
        {
            get { return product; }
            set
            {
                product = value;
                OnPropertyChanged("Products");
            }
        }

        public ViewModel()
        {
            product = new ObservableCollection<Product>();
            this.GetDetails();
        }

        private void GetDetails()
        {
            Products.Add(new Product(true, true, "P1", "HardWare", 1, "Mark", "C2", "India"));
            Products.Add(new Product(true, false, "P2", "Software", 2, "Jhon", "C1", "US"));
            Products.Add(new Product(false, true, "P3", "HardWare", 3, "Jhon Michel", "C3", "London"));
            Products.Add(new Product(true, false, "P4", "Software", 4, "Rose", "C4", "China"));
            Products.Add(new Product(false, false, "P5", "HardWare", 5, "Son", "C5", "Brazil"));
            Products.Add(new Product(true, false, "P6", "Software", 6, "Tom", "C6", "Mexico"));
            Products.Add(new Product(true, false, "P7", "HardWare", 7, "jery", "C7", "Japan"));
            Products.Add(new Product(false, false, "P8", "Software", 8, "Rose", "C8", "Russia"));
            Products.Add(new Product(true, false, "P9", "HardWare", 9, "Rick", "C9", "Italy"));
            Products.Add(new Product(false, true, "P10", "Software", 10, "Jery", "C10", "Koria"));
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                var e = new PropertyChangedEventArgs(propertyName);
                handler(this, e);
            }
        }
    }
}
